# ground-dashboard

## Setup
### Receiver
The ground Arduino software receives transmitted packets and sent them out to serial encoded in base 64. Install the ground.ino file using the Arduino IDE.

### Ground dashboard
The dashboard is a text-based tool for tracking and logging received telemetry. To use it, download a release from the GitHub project or build the dashboard using the following steps:

    $ cd ground/dashboard
    $ make install
    $ make build


Then, run the dashboard using the following `./build/white-vest-dashboard-Darwin-i386 --input /dev/cu.usbmodem143101 --output web`. 

Note that `white-vest-dashboard-Darwin-i386` will change based on the system you are using and `/dev/cu.usbmodem143101` is the path to the Arduino serial connection. To view the **web** dashboard, pass in `web` for the `--output` option and open http://localhost:8080/, to view the **text** dashboard pass in `text` for the `--output` option.


### Tool
The tool is a utility for after-flight work. To use it, download a release from the GitHub project or build the dashboard using the following steps:

    
```bash
$ cd ground/tool
$ make install
$ make build
```

The overall command structure is:

```bash
$ white-vest-tool [TASK] [FLAGS]
```

Taks/Flags:
* `convert`: Converts telemtry data to plain old JSON for analysis
  * `--input`: The file path to the input file
  * `--output`: The file path to output to
  * `--type`: The "type" of data. Right now the only valid option, and the default value, is `inboard`. This is the CSV file generated on the telemetry module during flight. I recommend reviewing the data and clipping the pre-launch and post-landing useless data for faster conversion.
  * `--progress`: `true` or `false`, print a progress bar during conversion
* `summary`: Analyze the data and print a few summary data points like apogee, max v, etc
  * `--input`: The file path to the input file (use the file made during `convert`)
* `chart`: Generate altitude and velocity charts
  * `--input`: The file path to the input file (use the file made during `convert`)
  * `--ouput`: The directory to save the charts to